var em = window.opener.em;
//http://omnipotent.net/jquery.sparkline/#docs
em.stats = {
  onLoad:function(){
    em.el('emMode', document).selectedIndex = 0;
  },
  load:function(){
    try {
      var data = [];
      var t = em.sql.query({
        sqlitem:'menuItem',
        sqlfunc:'selectOfficial',
        max:-1
      });
      if (!t.success || !t.total) {
        em.el('emStatsContent', document).innerHTML = "no results found!";
      } else for(var i=0;i<t.total;i++) {
        data.push({
          date:parseInt(t.data[i].date),
          ball:t.data[i].ball.match(/\d+/g),
          star:t.data[i].star.match(/\d+/g)
        });
      }
      return data;
    } catch(e) { if (em.DEBUG) em.alert(e, 'emBug0:'); }
  },
  changeDateSkip:true,
  changeMode:function(m,str){
    var mi = (!m?50:9);
    var ms = (!m?'ball':'star');
    try {
      if (!em.stats.changeModeSkip) { em.stats.changeModeSkip = true; return; }
      document.title = em.addon().name+' - Statistics for '+str;
      var data =  em.stats.load();
      var c = em.clean('emStatsContent', document);
      for(var i=1;i<=mi;i++) {
        var crunch = em.stats.crunch(ms, i, data);
        var s = em.elc('span', document);
        em.attr(s, 'class', 'sparky');
        em.attr(s, 'onmouseover', 'document.getElementById("emStatsDescription").innerHTML = "<img src=\'chrome://euromillions/skin/n/'+(m?'e':'')+(i<10?'0':'')+i+'.'+'gif\' style=\'width:17px;height:17px;margin-right:5px;\'/>'+crunch[1]+' times in '+crunch[2]+' draws, '+crunch[0]+' consecutive.'+'"');
        s.innerHTML = crunch.join(',');
        var img = em.elc('img', document);
        em.attr(img, 'style', 'width:17px;height:17px;margin-right:5px;');
        em.attr(img, 'src', 'chrome://euromillions/skin/n/'+(m?'e':'')+(i<10?'0':'')+i+'.'+'gif');
        em.add(c, img);
        em.add(c, s);
        em.add(c, em.elc('br', document));
      }
      $('.sparky').sparkline('html', {
        type:'bullet',
        targetColor:'green',
        performanceColor:'blue',
        fillColor:false,
        width:'350px',
        height:'auto'
      });
    } catch(e) { if (em.DEBUG) em.alert(e, 'emBug1:'); }
  },
  crunch:function(s,i,d){
    var a = 0;
    var c = 0;
    var cl = -2;
    for(var j=0;j<d.length;j++) {
      if (d[j][s].indexOf(i+'')!=-1) {
        a++;
        if (cl==(j-1))
          c++;
        cl = j;
      }
    }
    return [c, a, d.length];
  }
};